Index: protocols/bee.h
===================================================================
--- protocols/bee.h	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/bee.h	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -154,5 +154,5 @@
 G_MODULE_EXPORT void imcb_buddy_times(struct im_connection *ic, const char *handle, time_t login, time_t idle);
 /* Call when a handle says something. 'flags' and 'sent_at may be just 0. */
-G_MODULE_EXPORT void imcb_buddy_msg(struct im_connection *ic, const char *handle, char *msg, guint32 flags,
+G_MODULE_EXPORT void imcb_buddy_msg(struct im_connection *ic, const char *handle, const char *msg, guint32 flags,
                                     time_t sent_at);
 
Index: protocols/bee_user.c
===================================================================
--- protocols/bee_user.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/bee_user.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -68,4 +68,6 @@
 	}
 
+	bee->users = g_slist_remove(bee->users, bu);
+
 	g_free(bu->handle);
 	g_free(bu->fullname);
@@ -74,6 +76,4 @@
 	g_free(bu->status_msg);
 	g_free(bu);
-
-	bee->users = g_slist_remove(bee->users, bu);
 
 	return 1;
@@ -247,5 +247,5 @@
 }
 
-void imcb_buddy_msg(struct im_connection *ic, const char *handle, char *msg, uint32_t flags, time_t sent_at)
+void imcb_buddy_msg(struct im_connection *ic, const char *handle, const char *msg, uint32_t flags, time_t sent_at)
 {
 	bee_t *bee = ic->bee;
Index: protocols/jabber/Makefile
===================================================================
--- protocols/jabber/Makefile	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/Makefile	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -13,5 +13,5 @@
 
 # [SH] Program variables
-objects = conference.o io.o iq.o jabber.o jabber_util.o message.o presence.o s5bytestream.o sasl.o si.o
+objects = conference.o io.o iq.o jabber.o jabber_util.o message.o presence.o s5bytestream.o sasl.o si.o hipchat.o
 
 LFLAGS += -r
Index: protocols/jabber/conference.c
===================================================================
--- protocols/jabber/conference.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/conference.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -359,5 +359,5 @@
 
 	if (subject && chat) {
-		s = bud ? strchr(bud->ext_jid, '/') : NULL;
+		s = (bud && bud->ext_jid) ? strchr(bud->ext_jid, '/') : NULL;
 		if (s) {
 			*s = 0;
@@ -419,5 +419,5 @@
 	}
 	if (body && body->text_len > 0) {
-		s = strchr(bud->ext_jid, '/');
+		s = (bud->ext_jid) ? strchr(bud->ext_jid, '/') : NULL;
 		if (s) {
 			*s = 0;
Index: protocols/jabber/hipchat.c
===================================================================
--- protocols/jabber/hipchat.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
+++ protocols/jabber/hipchat.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -0,0 +1,93 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Jabber module - HipChat specific functions                               *
+*                                                                           *
+*  Copyright 2015 Xamarin Inc                                               *
+*                                                                           *
+*  This program is free software; you can redistribute it and/or modify     *
+*  it under the terms of the GNU General Public License as published by     *
+*  the Free Software Foundation; either version 2 of the License, or        *
+*  (at your option) any later version.                                      *
+*                                                                           *
+*  This program is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
+*  GNU General Public License for more details.                             *
+*                                                                           *
+*  You should have received a copy of the GNU General Public License along  *
+*  with this program; if not, write to the Free Software Foundation, Inc.,  *
+*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.              *
+*                                                                           *
+\***************************************************************************/
+
+#include "jabber.h"
+
+xt_status hipchat_handle_success(struct im_connection *ic, struct xt_node *node)
+{
+	struct jabber_data *jd = ic->proto_data;
+	char *sep, *jid;
+
+	jid = xt_find_attr(node, "jid");
+
+	sep = strchr(jid, '/');
+	if (sep) {
+		*sep = '\0';
+	}
+
+	jabber_set_me(ic, jid);
+	imcb_log(ic, "Setting Hipchat JID to %s", jid);
+
+	if (sep) {
+		*sep = '/';
+	}
+
+	/* Hipchat's auth doesn't expect a restart here */
+	jd->flags &= ~JFLAG_STREAM_RESTART;
+
+	if (!jabber_get_roster(ic) ||
+	    !jabber_iq_disco_server(ic) ||
+	    !jabber_get_hipchat_profile(ic)) {
+		return XT_ABORT;
+	}
+
+	return XT_HANDLED;
+}
+
+int jabber_get_hipchat_profile(struct im_connection *ic)
+{
+	struct jabber_data *jd = ic->proto_data;
+	struct xt_node *node;
+	int st;
+
+	imcb_log(ic, "Fetching hipchat profile for %s", jd->me);
+
+	node = xt_new_node("query", NULL, NULL);
+	xt_add_attr(node, "xmlns", XMLNS_HIPCHAT_PROFILE);
+	node = jabber_make_packet("iq", "get", jd->me, node);
+
+	jabber_cache_add(ic, node, jabber_parse_hipchat_profile);
+	st = jabber_write_packet(ic, node);
+
+	return st;
+}
+
+xt_status jabber_parse_hipchat_profile(struct im_connection *ic, struct xt_node *node, struct xt_node *orig)
+{
+	struct xt_node *query, *name_node;
+
+	if (!(query = xt_find_node(node->children, "query"))) {
+		imcb_log(ic, "Warning: Received NULL profile packet");
+		return XT_ABORT;
+	}
+
+	name_node = xt_find_node(query->children, "name");
+	if (!name_node) {
+		imcb_log(ic, "Warning: Can't find real name in profile. Joining groupchats will not be possible.");
+		return XT_ABORT;
+	}
+
+	set_setstr(&ic->acc->set, "display_name", name_node->text);
+	return XT_HANDLED;
+
+}
Index: protocols/jabber/iq.c
===================================================================
--- protocols/jabber/iq.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/iq.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -27,5 +27,4 @@
 static xt_status jabber_parse_roster(struct im_connection *ic, struct xt_node *node, struct xt_node *orig);
 static xt_status jabber_iq_display_vcard(struct im_connection *ic, struct xt_node *node, struct xt_node *orig);
-static int jabber_iq_disco_server(struct im_connection *ic);
 
 xt_status jabber_pkt_iq(struct xt_node *node, gpointer data)
@@ -374,4 +373,5 @@
 static xt_status jabber_parse_roster(struct im_connection *ic, struct xt_node *node, struct xt_node *orig)
 {
+	struct jabber_data *jd = ic->proto_data;
 	struct xt_node *query, *c;
 	int initial = (orig != NULL);
@@ -388,4 +388,5 @@
 		char *name = xt_find_attr(c, "name");
 		char *sub = xt_find_attr(c, "subscription");
+		char *mention_name = xt_find_attr(c, "mention_name");
 
 		if (jid && sub) {
@@ -396,4 +397,10 @@
 				if (name) {
 					imcb_rename_buddy(ic, jid, name);
+				}
+
+				/* This could also be used to set the full name as nick for fb/gtalk,
+				 * but i'm keeping the old (ugly?) default behavior just to be safe */
+				if (mention_name && (jd->flags & JFLAG_HIPCHAT)) {
+					imcb_buddy_nick_hint(ic, jid, mention_name);
 				}
 			} else if (strcmp(sub, "remove") == 0) {
@@ -855,5 +862,5 @@
                                                  struct xt_node *node, struct xt_node *orig);
 
-static int jabber_iq_disco_server(struct im_connection *ic)
+int jabber_iq_disco_server(struct im_connection *ic)
 {
 	struct xt_node *node, *iq;
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/jabber.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -61,6 +61,4 @@
 	s = set_add(&acc->set, "activity_timeout", "600", set_eval_int, acc);
 
-	s = set_add(&acc->set, "oauth", "false", set_eval_oauth, acc);
-
 	s = set_add(&acc->set, "display_name", NULL, NULL, acc);
 
@@ -83,4 +81,10 @@
 	s = set_add(&acc->set, "server", NULL, set_eval_account, acc);
 	s->flags |= SET_NOSAVE | ACC_SET_OFFLINE_ONLY | SET_NULL_OK;
+
+	if (strcmp(acc->prpl->name, "hipchat") == 0) {
+		set_setstr(&acc->set, "server", "chat.hipchat.com");
+	} else {
+		s = set_add(&acc->set, "oauth", "false", set_eval_oauth, acc);
+	}
 
 	s = set_add(&acc->set, "ssl", "false", set_eval_bool, acc);
@@ -121,4 +125,8 @@
 
 	jd->fd = jd->r_inpa = jd->w_inpa = -1;
+
+	if (strcmp(acc->prpl->name, "hipchat") == 0) {
+		jd->flags |= JFLAG_HIPCHAT;
+	}
 
 	if (jd->server == NULL) {
@@ -656,4 +664,5 @@
 {
 	struct prpl *ret = g_new0(struct prpl, 1);
+	struct prpl *hipchat = NULL;
 
 	ret->name = "jabber";
@@ -686,3 +695,8 @@
 
 	register_protocol(ret);
-}
+
+	/* Another one for hipchat, which has completely different logins */
+	hipchat = g_memdup(ret, sizeof(struct prpl));
+	hipchat->name = "hipchat";
+	register_protocol(hipchat);
+}
Index: protocols/jabber/jabber.h
===================================================================
--- protocols/jabber/jabber.h	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/jabber.h	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -48,4 +48,5 @@
 
 	JFLAG_GTALK =  0x100000,        /* Is Google Talk, as confirmed by iq discovery */
+	JFLAG_HIPCHAT = 0x200000,       /* Is hipchat, because prpl->name says so */
 
 	JFLAG_SASL_FB = 0x10000,        /* Trying Facebook authentication. */
@@ -235,4 +236,8 @@
 #define XMLNS_IBB          "http://jabber.org/protocol/ibb"                      /* XEP-0047 */
 
+/* Hipchat protocol extensions*/
+#define XMLNS_HIPCHAT         "http://hipchat.com"
+#define XMLNS_HIPCHAT_PROFILE "http://hipchat.com/protocol/profile"
+
 /* jabber.c */
 void jabber_connect(struct im_connection *ic);
@@ -249,4 +254,5 @@
 xt_status jabber_iq_query_server(struct im_connection *ic, char *jid, char *xmlns);
 void jabber_iq_version_send(struct im_connection *ic, struct jabber_buddy *bud, void *data);
+int jabber_iq_disco_server(struct im_connection *ic);
 
 /* si.c */
@@ -341,3 +347,8 @@
 void jabber_chat_invite(struct groupchat *c, char *who, char *message);
 
+/* hipchat.c */
+int jabber_get_hipchat_profile(struct im_connection *ic);
+xt_status jabber_parse_hipchat_profile(struct im_connection *ic, struct xt_node *node, struct xt_node *orig);
+xt_status hipchat_handle_success(struct im_connection *ic, struct xt_node *node);
+
 #endif
Index: protocols/jabber/jabber_util.c
===================================================================
--- protocols/jabber/jabber_util.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/jabber_util.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -566,4 +566,5 @@
 
 	if ((s = strchr(jid, '=')) == NULL) {
+		g_free(jid);
 		return NULL;
 	}
Index: protocols/jabber/s5bytestream.c
===================================================================
--- protocols/jabber/s5bytestream.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/s5bytestream.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -23,5 +23,4 @@
 
 #include "jabber.h"
-#include "sha1.h"
 #include "lib/ftutil.h"
 #include <poll.h>
@@ -42,5 +41,5 @@
 
 	/* SHA1( SID + Initiator JID + Target JID) */
-	char *pseudoadr;
+	char *pseudoaddr;
 
 	gint connect_timeout;
@@ -130,5 +129,5 @@
 	}
 
-	g_free(bt->pseudoadr);
+	g_free(bt->pseudoaddr);
 
 	while (bt->streamhosts) {
@@ -254,4 +253,29 @@
 }
 
+void jabber_bs_remove_events(struct bs_transfer *bt)
+{
+	struct jabber_transfer *tf = bt->tf;
+
+	if (tf->watch_out) {
+		b_event_remove(tf->watch_out);
+		tf->watch_out = 0;
+	}
+
+	if (tf->watch_in) {
+		b_event_remove(tf->watch_in);
+		tf->watch_in = 0;
+	}
+
+	if (tf->fd != -1) {
+		closesocket(tf->fd);
+		tf->fd = -1;
+	}
+
+	if (bt->connect_timeout) {
+		b_event_remove(bt->connect_timeout);
+		bt->connect_timeout = 0;
+	}
+}
+
 /* Bad luck */
 void jabber_bs_canceled(file_transfer_t *ft, char *reason)
@@ -260,4 +284,35 @@
 
 	imcb_log(tf->ic, "File transfer aborted: %s", reason);
+}
+
+static struct jabber_transfer *get_ft_by_sid(GSList *tflist, char *sid) {
+	GSList *l;
+	for (l = tflist; l; l = g_slist_next(l)) {
+		struct jabber_transfer *tft = l->data;
+		if ((strcmp(tft->sid, sid) == 0)) { 
+			return tft;
+		}
+	}
+	return NULL;
+}
+
+/* SHA1( SID + Initiator JID + Target JID ) is given to the streamhost which it will match against the initiator's value
+ * Returns a newly allocated string */
+static char *generate_pseudoaddr(char *sid, char *ini_jid, char *tgt_jid) {
+	char *contents = g_strconcat(sid, ini_jid, tgt_jid, NULL);
+	char *hash_hex = g_compute_checksum_for_string(G_CHECKSUM_SHA1, contents, -1);
+	g_free(contents);
+	return hash_hex;
+}
+
+static jabber_streamhost_t *jabber_streamhost_new(char *jid, char *host, int port)
+{
+	jabber_streamhost_t *sh = g_new0(jabber_streamhost_t, 1);
+	sh->jid = g_strdup(jid);
+	sh->host = g_strdup(host);
+	if (port) {
+		g_snprintf(sh->port, sizeof(sh->port), "%u", port);
+	}
+	return sh;
 }
 
@@ -270,13 +325,7 @@
 	struct jabber_data *jd = ic->proto_data;
 	struct jabber_transfer *tf = NULL;
-	GSList *tflist;
 	struct bs_transfer *bt;
 	GSList *shlist = NULL;
 	struct xt_node *shnode;
-
-	sha1_state_t sha;
-	char hash_hex[41];
-	unsigned char hash[20];
-	int i;
 
 	if (!(iq_id   = xt_find_attr(node, "id")) ||
@@ -303,9 +352,5 @@
 		    (port_s = xt_find_attr(shnode, "port")) &&
 		    (sscanf(port_s, "%d", &port) == 1)) {
-			jabber_streamhost_t *sh = g_new0(jabber_streamhost_t, 1);
-			sh->jid = g_strdup(jid);
-			sh->host = g_strdup(host);
-			sprintf(sh->port, "%u", port);
-			shlist = g_slist_append(shlist, sh);
+			shlist = g_slist_append(shlist, jabber_streamhost_new(jid, host, port));
 		}
 		shnode = shnode->next;
@@ -317,17 +362,5 @@
 	}
 
-	/* Let's see if we can find out what this bytestream should be for... */
-
-	for (tflist = jd->filetransfers; tflist; tflist = g_slist_next(tflist)) {
-		struct jabber_transfer *tft = tflist->data;
-		if ((strcmp(tft->sid, sid) == 0) &&
-		    (strcmp(tft->ini_jid, ini_jid) == 0) &&
-		    (strcmp(tft->tgt_jid, tgt_jid) == 0)) {
-			tf = tft;
-			break;
-		}
-	}
-
-	if (!tf) {
+	if (!(tf = get_ft_by_sid(jd->filetransfers, sid))) {
 		imcb_log(ic, "WARNING: Received bytestream request from %s that doesn't match an SI request", ini_jid);
 		return XT_HANDLED;
@@ -339,15 +372,4 @@
 
 	tf->ft->canceled = jabber_bs_canceled;
-
-	/* SHA1( SID + Initiator JID + Target JID ) is given to the streamhost which it will match against the initiator's value */
-	sha1_init(&sha);
-	sha1_append(&sha, (unsigned char *) sid, strlen(sid));
-	sha1_append(&sha, (unsigned char *) ini_jid, strlen(ini_jid));
-	sha1_append(&sha, (unsigned char *) tgt_jid, strlen(tgt_jid));
-	sha1_finish(&sha, hash);
-
-	for (i = 0; i < 20; i++) {
-		sprintf(hash_hex + i * 2, "%02x", hash[i]);
-	}
 
 	bt = g_new0(struct bs_transfer, 1);
@@ -356,5 +378,5 @@
 	bt->sh = shlist->data;
 	bt->phase = BS_PHASE_CONNECT;
-	bt->pseudoadr = g_strdup(hash_hex);
+	bt->pseudoaddr = generate_pseudoaddr(sid, ini_jid, tgt_jid);
 	tf->streamhandle = bt;
 	tf->ft->free = jabber_bs_free_transfer;
@@ -451,5 +473,5 @@
 			.rsv = 0,
 			.atyp = 0x03,
-			.addrlen = strlen(bt->pseudoadr),
+			.addrlen = strlen(bt->pseudoaddr),
 			.port = 0
 		};
@@ -468,5 +490,5 @@
 
 		/* copy hash into connect message */
-		memcpy(socks5_connect.address, bt->pseudoadr, socks5_connect.addrlen);
+		memcpy(socks5_connect.address, bt->pseudoaddr, socks5_connect.addrlen);
 
 		ASSERTSOCKOP(send(fd, &socks5_connect, sizeof(struct socks5_message), 0), "Sending SOCKS5 Connect");
@@ -558,4 +580,5 @@
 	if (shlist && shlist->next) {
 		bt->sh = shlist->next->data;
+		jabber_bs_remove_events(bt);
 		return jabber_bs_recv_handshake(bt, -1, 0);
 	}
@@ -731,5 +754,4 @@
 	struct jabber_data *jd = ic->proto_data;
 	struct bs_transfer *bt;
-	GSList *tflist;
 	struct xt_node *c;
 	char *sid, *jid;
@@ -750,13 +772,5 @@
 	/* Let's see if we can find out what this bytestream should be for... */
 
-	for (tflist = jd->filetransfers; tflist; tflist = g_slist_next(tflist)) {
-		struct jabber_transfer *tft = tflist->data;
-		if ((strcmp(tft->sid, sid) == 0)) {
-			tf = tft;
-			break;
-		}
-	}
-
-	if (!tf) {
+	if (!(tf = get_ft_by_sid(jd->filetransfers, sid))) {
 		imcb_log(ic, "WARNING: Received SOCKS5 bytestream reply to unknown request");
 		return XT_HANDLED;
@@ -776,18 +790,5 @@
 		/* using a proxy, abort listen */
 
-		if (tf->watch_in) {
-			b_event_remove(tf->watch_in);
-			tf->watch_in = 0;
-		}
-
-		if (tf->fd != -1) {
-			closesocket(tf->fd);
-			tf->fd = -1;
-		}
-
-		if (bt->connect_timeout) {
-			b_event_remove(bt->connect_timeout);
-			bt->connect_timeout = 0;
-		}
+		jabber_bs_remove_events(bt);
 
 		GSList *shlist;
@@ -838,5 +839,4 @@
 {
 	char *sid;
-	GSList *tflist;
 	struct jabber_transfer *tf = NULL;
 	struct xt_node *query;
@@ -846,13 +846,5 @@
 	sid = xt_find_attr(query, "sid");
 
-	for (tflist = jd->filetransfers; tflist; tflist = g_slist_next(tflist)) {
-		struct jabber_transfer *tft = tflist->data;
-		if ((strcmp(tft->sid, sid) == 0)) {
-			tf = tft;
-			break;
-		}
-	}
-
-	if (!tf) {
+	if (!(tf = get_ft_by_sid(jd->filetransfers, sid))) {
 		imcb_log(ic, "WARNING: Received SOCKS5 bytestream activation for unknown stream");
 		return XT_HANDLED;
@@ -883,8 +875,6 @@
 	*port++ = '\0';
 
-	sh = g_new0(jabber_streamhost_t, 1);
-	sh->jid = g_strdup(jid);
-	sh->host = g_strdup(host);
-	g_snprintf(sh->port, sizeof(sh->port), "%s", port);
+	sh = jabber_streamhost_new(jid, host, 0);
+	strncpy(sh->port, port, sizeof(sh->port));
 
 	return sh;
@@ -910,8 +900,6 @@
 		if (strcmp(proxy, "<local>") == 0) {
 			if ((tf->fd = ft_listen(&tf->saddr, host, port, jd->fd, FALSE, &errmsg)) != -1) {
-				sh = g_new0(jabber_streamhost_t, 1);
-				sh->jid = g_strdup(tf->ini_jid);
-				sh->host = g_strdup(host);
-				g_snprintf(sh->port, sizeof(sh->port), "%s", port);
+				sh = jabber_streamhost_new(tf->ini_jid, host, 0);
+				strncpy(sh->port, port, sizeof(sh->port));
 				bt->streamhosts = g_slist_append(bt->streamhosts, sh);
 
@@ -948,24 +936,9 @@
 {
 	struct bs_transfer *bt;
-	sha1_state_t sha;
-	char hash_hex[41];
-	unsigned char hash[20];
-	int i, ret;
-
-	/* SHA1( SID + Initiator JID + Target JID ) is given to the streamhost which it will match against the initiator's value */
-	sha1_init(&sha);
-	sha1_append(&sha, (unsigned char *) tf->sid, strlen(tf->sid));
-	sha1_append(&sha, (unsigned char *) tf->ini_jid, strlen(tf->ini_jid));
-	sha1_append(&sha, (unsigned char *) tf->tgt_jid, strlen(tf->tgt_jid));
-	sha1_finish(&sha, hash);
-
-	for (i = 0; i < 20; i++) {
-		sprintf(hash_hex + i * 2, "%02x", hash[i]);
-	}
 
 	bt = g_new0(struct bs_transfer, 1);
 	bt->tf = tf;
 	bt->phase = BS_PHASE_CONNECT;
-	bt->pseudoadr = g_strdup(hash_hex);
+	bt->pseudoaddr = generate_pseudoaddr(tf->sid, tf->ini_jid, tf->tgt_jid);
 	tf->streamhandle = bt;
 	tf->ft->free = jabber_bs_free_transfer;
@@ -974,7 +947,5 @@
 	jabber_si_set_proxies(bt);
 
-	ret = jabber_bs_send_request(tf, bt->streamhosts);
-
-	return ret;
+	return jabber_bs_send_request(tf, bt->streamhosts);
 }
 
@@ -1139,5 +1110,5 @@
 			                       socks5_connect.atyp);
 		}
-		if (!(memcmp(socks5_connect.address, bt->pseudoadr, 40) == 0)) {
+		if (!(memcmp(socks5_connect.address, bt->pseudoaddr, 40) == 0)) {
 			return jabber_bs_abort(bt, "SOCKS5 Connect message contained wrong digest");
 		}
Index: protocols/jabber/sasl.c
===================================================================
--- protocols/jabber/sasl.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/jabber/sasl.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -42,5 +42,5 @@
 	"https://www.facebook.com/dialog/oauth",
 	"https://graph.facebook.com/oauth/access_token",
-	"http://www.bitlbee.org/main.php/Facebook/oauth2.html",
+	"https://www.bitlbee.org/main.php/Facebook/oauth2.html",
 	"offline_access,xmpp_login",
 	"126828914005625",
@@ -55,5 +55,5 @@
 	char *s;
 	int sup_plain = 0, sup_digest = 0, sup_gtalk = 0, sup_fb = 0;
-	int want_oauth = FALSE;
+	int want_oauth = FALSE, want_hipchat = FALSE;
 	GString *mechs;
 
@@ -75,4 +75,5 @@
 
 	want_oauth = set_getbool(&ic->acc->set, "oauth");
+	want_hipchat = (jd->flags & JFLAG_HIPCHAT);
 
 	mechs = g_string_new("");
@@ -111,5 +112,9 @@
 
 	reply = xt_new_node("auth", NULL, NULL);
-	xt_add_attr(reply, "xmlns", XMLNS_SASL);
+	if (!want_hipchat) {
+		xt_add_attr(reply, "xmlns", XMLNS_SASL);
+	} else {
+		xt_add_attr(reply, "xmlns", XMLNS_HIPCHAT);
+	}
 
 	if (sup_gtalk && want_oauth) {
@@ -143,13 +148,31 @@
 	} else if (sup_plain) {
 		int len;
-
-		xt_add_attr(reply, "mechanism", "PLAIN");
+		GString *gs;
+		char *username;
+
+		if (!want_hipchat) {
+			xt_add_attr(reply, "mechanism", "PLAIN");
+			username = jd->username;
+		} else {
+			username = jd->me;
+		}
+
+		/* set an arbitrary initial size to avoid reallocations */
+		gs = g_string_sized_new(128);
 
 		/* With SASL PLAIN in XMPP, the text should be b64(\0user\0pass) */
-		len = strlen(jd->username) + strlen(ic->acc->pass) + 2;
-		s = g_malloc(len + 1);
-		s[0] = 0;
-		strcpy(s + 1, jd->username);
-		strcpy(s + 2 + strlen(jd->username), ic->acc->pass);
+		g_string_append_c(gs, '\0');
+		g_string_append(gs, username);
+		g_string_append_c(gs, '\0');
+		g_string_append(gs, ic->acc->pass);
+		if (want_hipchat) {
+			/* Hipchat's variation adds \0resource at the end */
+			g_string_append_c(gs, '\0');
+			g_string_append(gs, set_getstr(&ic->acc->set, "resource"));
+		}
+
+		len = gs->len;
+		s = g_string_free(gs, FALSE);
+
 		reply->text = base64_encode((unsigned char *) s, len);
 		reply->text_len = strlen(reply->text);
@@ -397,4 +420,8 @@
 		imcb_log(ic, "Authentication finished");
 		jd->flags |= JFLAG_AUTHENTICATED | JFLAG_STREAM_RESTART;
+
+		if (jd->flags & JFLAG_HIPCHAT) {
+			return hipchat_handle_success(ic, node);
+		}
 	} else if (strcmp(node->name, "failure") == 0) {
 		imcb_error(ic, "Authentication failure");
Index: protocols/msn/Makefile
===================================================================
--- protocols/msn/Makefile	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/msn/Makefile	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -13,5 +13,5 @@
 
 # [SH] Program variables
-objects = msn.o msn_util.o ns.o sb.o soap.o tables.o
+objects = msn.o msn_util.o ns.o soap.o tables.o gw.o
 
 LFLAGS += -r
Index: protocols/msn/gw.c
===================================================================
--- protocols/msn/gw.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
+++ protocols/msn/gw.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -0,0 +1,196 @@
+#include "bitlbee.h"
+#include "lib/http_client.h"
+#include "msn.h"
+
+#define GATEWAY_HOST "geo.gateway.messenger.live.com"
+#define GATEWAY_PORT 443
+
+#define REQUEST_TEMPLATE \
+	"POST /gateway/gateway.dll?SessionID=%s&%s HTTP/1.1\r\n" \
+	"Host: %s\r\n" \
+	"Content-Length: %zd\r\n" \
+	"\r\n" \
+	"%s"
+
+static gboolean msn_gw_poll_timeout(gpointer data, gint source, b_input_condition cond);
+
+struct msn_gw *msn_gw_new(struct im_connection *ic)
+{
+	struct msn_gw *gw = g_new0(struct msn_gw, 1);
+	gw->last_host = g_strdup(GATEWAY_HOST);
+	gw->port = GATEWAY_PORT;
+	gw->ssl = (GATEWAY_PORT == 443);
+	gw->poll_timeout = -1;
+	gw->ic = ic;
+	gw->md = ic->proto_data;
+	gw->in = g_byte_array_new();
+	gw->out = g_byte_array_new();
+	return gw;
+}
+
+void msn_gw_free(struct msn_gw *gw)
+{
+	if (gw->poll_timeout != -1) {
+		b_event_remove(gw->poll_timeout);
+	}
+	g_byte_array_free(gw->in, TRUE);
+	g_byte_array_free(gw->out, TRUE);
+	g_free(gw->session_id);
+	g_free(gw->last_host);
+	g_free(gw);
+}
+
+static struct msn_gw *msn_gw_from_ic(struct im_connection *ic)
+{
+	if (g_slist_find(msn_connections, ic) == NULL) {
+		return NULL;
+	} else {
+		struct msn_data *md = ic->proto_data;
+		return md->gw;
+	}
+}
+
+static gboolean msn_gw_parse_session_header(struct msn_gw *gw, char *value)
+{
+	int i;
+	char **subvalues;
+	gboolean closed = FALSE;
+
+	subvalues = g_strsplit(value, "; ", 0);
+
+	for (i = 0; subvalues[i]; i++) {
+		if (strcmp(subvalues[i], "Session=close") == 0) {
+			/* gateway closed, signal the death of the socket */
+			closed = TRUE;
+		} else if (g_str_has_prefix(subvalues[i], "SessionID=")) {
+			/* copy the part after the = to session_id*/
+			g_free(gw->session_id);
+			gw->session_id = g_strdup(subvalues[i] + 10);
+		}
+	}
+
+	g_strfreev(subvalues);
+
+	return !closed;
+}
+
+void msn_gw_callback(struct http_request *req)
+{
+	struct msn_gw *gw;
+	char *value;
+
+	if (!(gw = msn_gw_from_ic(req->data))) {
+		return;
+	}
+
+	gw->waiting = FALSE;
+	gw->polling = FALSE;
+
+	if (getenv("BITLBEE_DEBUG")) {
+		fprintf(stderr, "\n\x1b[90mHTTP:%s\n", req->reply_body);
+		fprintf(stderr, "\n\x1b[97m\n");
+	}
+
+	if (req->status_code != 200) {
+		gw->callback(gw->md, -1, B_EV_IO_READ);
+		return;
+	}
+
+	if ((value = get_rfc822_header(req->reply_headers, "X-MSN-Messenger", 0))) {
+		if (!msn_gw_parse_session_header(gw, value)) {
+			gw->callback(gw->md, -1, B_EV_IO_READ);
+			g_free(value);
+			return;
+		}
+		g_free(value);
+	}
+	
+	if ((value = get_rfc822_header(req->reply_headers, "X-MSN-Host", 0))) {
+		g_free(gw->last_host);
+		gw->last_host = value; /* transfer */
+	}
+
+	if (req->body_size) {
+		g_byte_array_append(gw->in, (const guint8 *) req->reply_body, req->body_size);
+		gw->callback(gw->md, -1, B_EV_IO_READ);
+	}
+
+	if (gw->poll_timeout != -1) {
+		b_event_remove(gw->poll_timeout);
+	}
+	gw->poll_timeout = b_timeout_add(500, msn_gw_poll_timeout, gw->ic);
+
+}
+
+void msn_gw_dorequest(struct msn_gw *gw, char *args)
+{
+	char *request = NULL;
+	char *body = NULL;
+	size_t bodylen = 0;
+
+	if (gw->out) {
+		bodylen = gw->out->len;
+		g_byte_array_append(gw->out, (guint8 *) "", 1); /* nullnullnull */
+		body = (char *) g_byte_array_free(gw->out, FALSE);
+		gw->out = g_byte_array_new();
+	}
+
+	if (!bodylen && !args) {
+		args = "Action=poll&Lifespan=60";
+		gw->polling = TRUE;
+	}
+
+	request = g_strdup_printf(REQUEST_TEMPLATE,
+		gw->session_id ? : "", args ? : "", gw->last_host, bodylen, body ? : "");
+
+	http_dorequest(gw->last_host, gw->port, gw->ssl, request, msn_gw_callback, gw->ic);
+	gw->open = TRUE;
+	gw->waiting = TRUE;
+
+	g_free(body);
+	g_free(request);
+}
+
+void msn_gw_open(struct msn_gw *gw)
+{
+	msn_gw_dorequest(gw, "Action=open&Server=NS");
+}
+
+static gboolean msn_gw_poll_timeout(gpointer data, gint source, b_input_condition cond)
+{
+	struct msn_gw *gw;
+
+	if (!(gw = msn_gw_from_ic(data))) {
+		return FALSE;
+	}
+
+	gw->poll_timeout = -1;
+	if (!gw->waiting) {
+		msn_gw_dorequest(gw, NULL);
+	}
+	return FALSE;
+}
+
+ssize_t msn_gw_read(struct msn_gw *gw, char **buf)
+{
+	size_t bodylen;
+	if (!gw->open) {
+		return 0;
+	}
+
+	bodylen = gw->in->len;
+	g_byte_array_append(gw->in, (guint8 *) "", 1); /* nullnullnull */
+	*buf = (char *) g_byte_array_free(gw->in, FALSE);
+	gw->in = g_byte_array_new();
+	return bodylen;
+}
+
+void msn_gw_write(struct msn_gw *gw, char *buf, size_t len)
+{
+	g_byte_array_append(gw->out, (const guint8 *) buf, len);
+	if (!gw->open) {
+		msn_gw_open(gw);
+	} else if (gw->polling || !gw->waiting) {
+		msn_gw_dorequest(gw, NULL);
+	}
+}
